<?php 
/***
 * Plugin Name:       Backgroundcut background changer
 * Plugin URI:        https://backgroundcut.co/
 * Description:       The plugin to change the background image transparent of any product's image. This plugin is based on woocoomerce plugin. So activation of woocommerce plugin is must.
 * Version:           1.0
 * Author:            backgroundcut
 * Developer: Sohag Srz
 * Developer Uri: https://facebook.com/sohagsrz
 * Author URI:        https://backgroundcut.co/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       backgroundcut-background-changer
 * Domain Path:       /languages
 */
 
 // No direct accessable
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly


//constants
define( 'BACKGROUNDCUT_CHANGER_VERSION', '1.0' );
define( 'BACKGROUNDCUT_ROOT_URL', plugin_dir_url( __FILE__ ) );
define( 'backgroundcut_ROOT_URL', plugin_dir_url( __FILE__ ) );
define('BACKGROUNDCUT_ROOT_DIR', plugin_dir_path(__FILE__));
define('BACKGROUNDCUT_BASE_NAME', plugin_basename(__FILE__));
define('BACKGROUNDCUT_FILE',__FILE__);


require_once plugin_dir_path( __FILE__ ) . 'includes/backgroundcut-background-changer.php';

 

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-backgroundcut-background-changer-activator.php
 */
function activate_backgroundcut_background_changer() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-backgroundcut-background-changer-activator.php';
	BackgroundCut_Background_Changer_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-backgroundcut-background-changer-deactivator.php
 */
function deactivate_backgroundcut_background_changer() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-backgroundcut-background-changer-deactivator.php';
	BackgroundCut_Background_Changer_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_backgroundcut_background_changer' );
register_deactivation_hook( __FILE__, 'deactivate_backgroundcut_background_changer' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-backgroundcut-changer.php';
 

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_backgroundcut_changer_init() {

	$plugin = new Backgroundcut_Changer();
	$plugin->run();

}
run_backgroundcut_changer_init();
 
 
add_filter( 'plugin_row_meta', 'backgroundcut_support_and_contact_links', 10, 4 );
function backgroundcut_support_and_contact_links( $links_array, $plugin_file_name, $plugin_data, $status )
{
  if( strpos( $plugin_file_name, basename(__FILE__) ))
  {
    $links_array[] = 'Support: support@backgroundcut.co';
  }
  return $links_array;
}

if(!function_exists('bg_log_srz')){
function bg_log_srz($write){
    	    $write=$write."\n";
    	    $upload_dir = wp_upload_dir();
			$folder = $upload_dir['basedir'] . '/srz-bg-log';
			if(!file_exists($folder)) wp_mkdir_p($folder);
			$fileUrlsDone= $folder .'/bg.log'; 
			if (!file_exists($fileUrlsDone)) {
				$DoneJson= array();
				file_put_contents($fileUrlsDone, $write);
			}else{ 
			    $current = $write;
			    file_put_contents($fileUrlsDone, $current, FILE_APPEND | LOCK_EX);
			} 

			
    	}
}
