<?php

add_action('wp_ajax_get_all_image_ids', 'get_all_image_ids');

add_action('wp_ajax_nopriv_get_all_image_ids', 'get_all_image_ids');


function get_all_image_ids(){

    global $wpdb;

    $data = array();

    $arr = array();

    $delete_query = 'delete from `'.$wpdb->prefix.'wc_backgroundcut_process_status` where status="0"';

    $wpdb->query($delete_query);

    $backgroundcut_product_ids = sanitize_text_field($_POST['backgroundcut_product_ids']);

    if($backgroundcut_product_ids == 'all'){

        $val = get_posts(array('post_type' => 'product', 'numberposts' => -1, 'post_status' => 'publish', 'update_post_meta_cache' => false, 'fields' => 'ids',));

        $backgroundcut_product_ids = implode(',', $val);

    }



    $arr_product_ids = explode(",", $backgroundcut_product_ids);

    
    $is_select_main_image = sanitize_text_field($_POST['backgroundcut_product_image']);

    $is_select_gallery_image = sanitize_text_field($_POST['backgroundcut_gallery_image']);

    $is_include_processed_image = sanitize_text_field($_POST['is_backgroundcut_include_processed_image']);


    if ($is_select_main_image == 'FALSE' && $is_select_gallery_image == 'FALSE') {

        $arr['status'] = false;

        $arr['message'] = "Please choose target image.";

        echo json_encode($arr);

        exit();

    }

    if (count($arr_product_ids) == 0) {

        $arr['status'] = false;

        $arr['message'] = "Product not found.";

        echo json_encode($arr);

        exit();

    }

    $all_gallery_image = true;

    $Backgroundcut_gallery_image_IDs = get_option('Backgroundcut_gallery_image_IDs');
    $backgroundcut_products = get_option('backgroundcut_products');

    if($backgroundcut_products == 'specified' && $Backgroundcut_gallery_image_IDs ){
        $all_gallery_image = false;
        $gallery_process_images = explode(',',$Backgroundcut_gallery_image_IDs);        
    }


    

    foreach ($arr_product_ids as $product_id) {

        if ($is_select_main_image == 'TRUE') {

            $product_object = wc_get_product($product_id);

            if(isset($product_object) && $product_object != '') {

                $image_id = $product_object->get_image_id();

                if (!empty($image_id)) {

                    $table_name = $wpdb->prefix."wc_backgroundcut_process_status";

                    $product_status_insert_args = array(
                        'product_id' => $product_id,
                        'image_id' => $image_id,
                        'status' => 0,
                        'type' => 'product_image'
                    );
                    

                    if ($is_include_processed_image == 'TRUE') {

                        $wpdb->insert($table_name, $product_status_insert_args);                     

                    } else {

                        if (!is_image_processed($product_id, $image_id)) {

                          $wpdb->insert($table_name, $product_status_insert_args);   

                       }

                    }

                }

            }

        }



        if ($is_select_gallery_image == 'TRUE') {

            $attachment_ids = get_post_meta($product_id, '_product_image_gallery', true);

            if (!empty($attachment_ids)) {
                
                update_post_meta($product_id,'_product_gallery_original_images',$attachment_ids);
                $attachment_ids = explode(',', $attachment_ids);

                if (is_array($attachment_ids)) {

                    $table_name = $wpdb->prefix."wc_backgroundcut_process_status";

                    $attachment_args = array(
                        'product_id' => $product_id,
                        'status' => 0,
                        'type' => 'gallery_image'
                    );

                    foreach ($attachment_ids as $attachment_id) {

                        if (!empty($attachment_id)) {

                            if($all_gallery_image == false && !in_array($attachment_id,$gallery_process_images)){
                                continue;
                            }

                            $attachment_args['image_id'] = $attachment_id;

                            if ($is_include_processed_image == 'TRUE') {

                              $wpdb->insert($table_name, $attachment_args); 

                            } else {

                               if (!is_image_processed($product_id, $attachment_id)) {

                                    $wpdb->insert($table_name, $attachment_args); 

                               }

                            }

                        }

                    }

                }

            }

        }

    }





    $sql = "SELECT * FROM `" . $wpdb->prefix . "wc_backgroundcut_process_status` WHERE status = 0";

    $res = $wpdb->get_results(  $sql );

    

    if(count($res) > 0){

        $sql = "UPDATE `".$wpdb->prefix."wc_backgroundcut_process_history` SET `can_restore_or_delete` = 0";

        $wpdb->query($sql);       

    }

    $arr['status'] = true;

    $arr['count'] = count($res);

   

    echo json_encode($arr);

    exit();

}



function is_image_processed($product_id, $image_id)

{

     global $wpdb;

    $sql = "SELECT * FROM `" . $wpdb->prefix . "wc_backgroundcut_process_history` WHERE product_id= ".$product_id." AND attach_id = ".$image_id;

    $res = $wpdb->get_results( $sql);

    if ( count($res) > 0){

        return true;

    }

    return false;
}
?>