<?php

add_action('wp_ajax_start_processing_single_image', 'start_processing_single_image');

add_action('wp_ajax_nopriv_start_processing_single_image', 'start_processing_single_image');



function start_processing_single_image(){

    global $wpdb;

    $backgroundcut_api_key = get_option('backgroundcut_live_key');

    $sql = "SELECT * FROM `".$wpdb->prefix."wc_backgroundcut_process_status` WHERE `status` = 0 ORDER BY id ASC LIMIT 1";


    $res = $wpdb->get_results($sql );


    if(count($res) > 0){

        $product_id = $res[0]->product_id;

        $image_id = $res[0]->image_id;

        $type = $res[0]->type;

        $id = $res[0]->id;


        update_option('show_backup', 1);


        $arr_media_image = get_base64_image($image_id);

        $old_image_file_name = $arr_media_image['old_image_file_name'];



        $arr_request_body = get_request_body($arr_media_image,$old_image_file_name);

    
        $arr_response_body = remove_image_background($arr_request_body,$backgroundcut_api_key);

    
        if ($arr_response_body['continue']) {

            $sql = "UPDATE `".$wpdb->prefix."wc_backgroundcut_process_status` SET `status` = 1 WHERE id=".$id;


            $wpdb->query($sql);

             
            $image_urls = json_decode($arr_response_body['api_response'],true);
            $image_url = $image_urls['output_image_url'];
bg_log_srz("img api url => $image_url");
            $attach_id = download_image_from_url($image_url, $product_id,$old_image_file_name);
bg_log_srz("image uploaded , attachment id  => $attach_id");
 

            if ($image_id) {
                 $can_restore_or_delete = 1;

                    // $sql = "INSERT INTO `".$wpdb->prefix."wc_backgroundcut_process_history` (image_id, product_id, attach_id, can_restore_or_delete) VALUES (".$image_id.", ".$product_id.", ".$attach_id.", ".$can_restore_or_delete.")";


                    $args = array(
                        'image_id' => $image_id,
                        'product_id' => $product_id,
                        'attach_id' => $attach_id,
                        'can_restore_or_delete' => $can_restore_or_delete
                    );
                

                    $wpdb->insert($wpdb->prefix."wc_backgroundcut_process_history",$args);                

            }

 

            if ($type == "product_image")

            {

                update_post_meta($product_id, '_thumbnail_id_backup', $image_id);

                set_post_thumbnail($product_id, $attach_id);

            }



            if ($type == "gallery_image"){


                // first take backup
                $string_checkalreadybackup = get_post_meta($product_id, '_product_image_gallery_backup', true);

                $array_of_gallery_images_forbackup = array();



                if (!empty($string_checkalreadybackup)) {

                    $array_of_gallery_images_forbackup = explode(",", $string_checkalreadybackup);

                    if (!in_array($image_id, $array_of_gallery_images_forbackup)) {

                        array_push($array_of_gallery_images_forbackup, $image_id);

                        $newstring_forbackup = implode(',', $array_of_gallery_images_forbackup);

                        update_post_meta($product_id, '_product_image_gallery_backup', $newstring_forbackup);

                    }

                } else {

                    update_post_meta($product_id, '_product_image_gallery_backup', $image_id);

                }



                $string_gallery_images = get_post_meta($product_id, '_product_image_gallery', true);

                $array_of_gallery_images = explode(",", $string_gallery_images);

                $array_of_gallery_images_new = array_replace($array_of_gallery_images,

                    array_fill_keys(

                        array_keys($array_of_gallery_images, $image_id),

                        $attach_id

                    )

                );



                $newstring = implode(',', $array_of_gallery_images_new);

                update_post_meta($product_id, '_product_image_gallery', $newstring);



            }   
            $sql = "SELECT * FROM `".$wpdb->prefix."wc_backgroundcut_process_status` WHERE `status` = 0";

            $res = $wpdb->get_results($sql );

            $img_count = count($res);

            echo json_encode(array('status' => true, 'message' => 'success', 'count' => $img_count,'remaining_credits' => ''));

        } else {
            $error = $arr_response_body['status'];
            $msger='';
            if($error==400){
                 $msger='Invalid parameters or unable to process input image file (No credit deducted)';
            }elseif($error==401){
                 $msger='API-KEY missing or invalid API-KEY (No credit deducted)';
            
            }
            elseif($error==402){
                 $msger='No credits remaining (No credit deducted)';
            }
            elseif($error==429){
                 $msger='API rate limit crossed (No credit deducted)';
            }
            elseif($error==400){}
            echo json_encode(array('status' => false, 'message' =>$msger));

        }

        exit;

    }else{

        echo json_encode(array('status' => false, 'message' => 'Background removal completed.'));

         exit;

    }

    

}



?>